# pict-rs 0.5.9

## Overview

pict-rs 0.5.9 is a bugfix release for 0.5.8. All deployments on 0.5.8 should upgrade to 0.5.9

### Fixes

- [Fix Postgres Pooling](#fix-postgres-pooling)
- [Fix io-uring feature](#fix-io-uring-feature)


## Upgrade Notes

There are no significant changes from 0.5.8. Upgrading should be as simple as pulling the new
version.


## Descriptions

### Fix Postgres Pooling

When pict-rs 0.5.7 was built without the `tokio_unstable` flag, it would use tokio's `spwan_local`
utility from outside a LocalSet, leading to panics and timeouts. This release replaces the use of
`spawn_local` with `spawn` in that scenario.


### Fix io-uring Feature

As mentioned in the 0.5.7 release notes, io-uring is not considered to be a stable feature. However,
0.5.8 should make it usable again. Instead of manually launching a tokio_uring runtime, pict-rs once
again relies on actix-rt to configure a System for use with io-uring.
